{***************************************************************
  DSOA MK3 Version 1.0
  (c)1997 David L. Jones & David Bulfoni TRONNORT Technology
  For use with the DSOA Mk3 Rev2.1 hardware
  Last Edited : 13/5/98
****************************************************************}
unit Dsoa3_10;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Spin, Menus,
  DSOA3_I2, DSOA3_D3, DSOA3_A1,
  Printers;

type
  TMainScreen = class(TForm)
    DISPLAY: TRadioGroup;
    MODE: TRadioGroup;
    CH1: TGroupBox;
    CH1setting: TComboBox;
    CH2setting: TComboBox;
    CH2: TGroupBox;
    TimeBase: TGroupBox;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Options1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Load1: TMenuItem;
    Save1: TMenuItem;
    Print1: TMenuItem;
    PrintSetup1: TMenuItem;
    Export1: TMenuItem;
    Exit: TMenuItem;
    xoff: TScrollBar;
    Timer1: TTimer;
    StartSample: TButton;
    StopSample: TButton;
    SingleShot: TButton;
    Cursor: TRadioGroup;
    Graticule: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    PrintDialog1: TPrintDialog;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    PortAdress1: TMenuItem;
    N378H1: TMenuItem;
    N278H1: TMenuItem;
    N3BCH1: TMenuItem;
    Label1: TLabel;
    Delay: TCheckBox;
    Label2: TLabel;
    Label3: TLabel;
    TimeBaseSetting: TComboBox;
    DelayTimeBase: TComboBox;
    ZoomUp: TButton;
    ZoomDown: TButton;
    TimeUp: TButton;
    TimeDown: TButton;
    PrinterSetupDialog1: TPrinterSetupDialog;
    TrigPol: TRadioGroup;
    TrigMode: TRadioGroup;
    Averages: TMenuItem;
    Timer2: TTimer;
    Image1: TImage;
    ddisp: TPanel;
    line5: TLabel;
    line4: TLabel;
    line3: TLabel;
    line2: TLabel;
    line1: TLabel;
    AVR128: TMenuItem;
    AVR64: TMenuItem;
    AVR32: TMenuItem;
    AVR16: TMenuItem;
    AVR8: TMenuItem;
    AVR4: TMenuItem;
    SaveDialog2: TSaveDialog;
    procedure MainLoop(Sender: TObject);
    procedure InitialiseData(Sender: TObject);
    procedure SetTimebase(Sender: TObject);
    procedure N378H1Click(Sender: TObject);
    procedure N278H1Click(Sender: TObject);
    procedure N3BCH1Click(Sender: TObject);
    procedure ZoomUpClick(Sender: TObject);
    procedure ZoomDownClick(Sender: TObject);
    procedure DelaySetting(Sender: TObject);
    procedure DelayOn(Sender: TObject);
    procedure TimeUpClick(Sender: TObject);
    procedure TimeDownClick(Sender: TObject);
    procedure GraticuleClick(Sender: TObject);
    procedure xoffChange(Sender: TObject);
    procedure SingleShotClick(Sender: TObject);
    procedure StartSampleClick(Sender: TObject);
    procedure StopSampleClick(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure TrigPolClick(Sender: TObject);
    procedure CH1settingChange(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure PrintSetup1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure MODEClick(Sender: TObject);
    procedure CH2settingChange(Sender: TObject);
    procedure ExitClick(Sender: TObject);
    procedure CursorMark(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CursorTrace(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
     procedure AVR128Click(Sender: TObject);
     procedure AVR64Click(Sender: TObject);
     procedure AVR32Click(Sender: TObject);
     procedure AVR16Click(Sender: TObject);
     procedure AVR8Click(Sender: TObject);
     procedure AVR4Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

status = record
            Channel   : byte; {0=ch1, 1=ch2, 2=both, 3=add, 4=sub}
            volts1    : byte; { voltage / div setting (index value)}
            volts2    : byte;
            timebase  : byte; { time / div setting (index setting)}
            Delay     : byte; { time / div Setting (index Setting)}
            samples   : byte; { number of sample per division to be displayed}
            mode      : boolean; { true = continously , false = one shot mode }
            run       : boolean; { true = run , false = stop}
            DelayMode : boolean; { true = delay time base }
            DispMode  : byte; {0 = RealTime, 1 = History, 2 = Average}
            FileName  : String; {the current filename}
         end;

const
  RAMsize=1024;             {Size of FIFO}
  tval : array [0..5] of word = (100,40,20,10,4,2);
  DebugMode = false;
  MaxAverages=128;  {maximum num of averages}
  cfgfilename = 'dsoa.dsc';

Type
  Data_Array = array[1..2,1..RAMsize] of byte;
  File_Array = record
                 Stat : Status;
                 Data : Data_Array;
               end;
var
  MainScreen: TMainScreen;   {Main Screen layout}
  Grid:Boolean;              {True=ON, False=OFF}
  Disp:array[1..2,1..500] of integer; {waveform display array}
  Data: Data_Array; {array[1..2,1..RAMsize] of byte;}
  AVRsum:array[1..2,1..RAMsize] of word; {calc. average sum}
  NumSamplesDiv :word;    {num of samples per division}
  NumAverages:byte;    {num of averages to do}
  AverageCount:word;   {current average counter}
  AutoTimeout:boolean; {Auto trigger timer flag}
  stat : status;
  TimeVal,TVal1,TVal2 : integer;
  ET1,ET2,etmin,etmax : double;
  VoltVal,VVal1,VVal2 : word;
  cursorson : boolean;
  scn,blankscn : tbitmap;
  hist : array[1..3] of tbitmap;
  cursorbuttontag1 : boolean;
  cursorbuttontag2 : boolean;
  DSWFile : File_Array;

implementation

{$R *.DFM}

{$R+}

{**********************************************}
procedure ClearHistoryDisplay;
var l:byte;
    t:word;
begin
  for l := 1 to 3 do
     with hist[l].canvas do begin
        pen.color := clwhite;
        rectangle (0,0,500,256);
     end;
end;

{***********************************************}
procedure ClearCanvas;
begin
  scn.canvas.draw(0,0,blankscn);
end;

{************************************************
  Draws both waveforms from the display memory
  data array ("disp[]")
*************************************************}
procedure DrawWaveforms;
var x,c,xx,yy,x0,xt,d0,m0,tt,sumval,subval :word;
  trig_view : boolean;
  eval1,eval2 : longint;
begin
  xx := 23;
  yy := 279;
  ClearCanvas;
  { test if trigger time position is to be displayed }
  x0 := mainscreen.xoff.position;
  trig_view := false;
  case NumSamplesDiv of
     100: begin trig_view := true; mainscreen.xoff.position := 2;end;
     40: case x0 of 0..10:   trig_view:=true; end;
     20: case x0 of 15..25:  trig_view:=true; end;
     10: case x0 of 40..50:  trig_view:=true; end;
     4: case x0 of 115..125: trig_view:=true; end;
     2: case x0 of 240..250: trig_view:=true; end;
  end;

  { Displaying Trigger indicators (Time Position & Trigger Level) }
  d0 := mainscreen.display.itemindex;

  { Displaying History of Waveforms }
  m0 := mainscreen.mode.itemindex;
  if m0 = 1 then
     case d0 of
        0..2: scn.canvas.draw(22,23,hist[d0+1]);
     end;

  { Display Grid  }
  if grid then Draw_grid (23,23,scn.width-23,scn.height-23,scn.canvas);

  { Displaying Trigger Time Position }
  if trig_view=true then begin
     case NumSamplesDiv of
        100: xt:= xx+250;
        40: xt:= xx+500-(x0)*50;
        20: xt:= xx+500-(x0-15)*50;
        10: xt:= xx+500-(x0-40)*50;
        4: xt:= xx+500-(x0-115)*50;
        2: xt:= xx+500-(x0-240)*50;
     end;
     with scn.canvas do begin
        pen.color:=clblue;
        moveto (xt,yy-256);     lineto (xt,yy);
        moveto (xt,yy-256);     lineto (xt-5,yy-256-5);
        lineto (xt+5,yy-256-5); lineto (xt,yy-256);
     end;
  end;

  with scn.canvas do begin
     { Displaying The Trigger Level Indicator }
     if (d0 >= 0) and (d0 <= 2) then begin
        pen.color := clblue;
        tt := data[1,RAMsize div 2];
        moveto (xx+500,yy-tt);
        lineto (xx+504,yy-tt-5);
        lineto (xx+504,yy-tt+5);
        lineto (xx+500,yy-tt);
     end;

      { Display Waveform in Channel 1 Buffer }
     if (d0=0) or (d0 = 2) then begin
        Pen.Color:=clRed;
        MoveTo(xx,yy-Disp[1,1]);
        for c:=1 to 500 do
           LineTo(xx+c,yy-Disp[1,c]);
     end;

      { Display Waveform in Channel 2 Buffer }
     if (d0=1) or (d0=2) then begin
        Pen.Color:=clGreen;
        MoveTo(xx,yy-Disp[2,1]);
        for c:=1 to 500 do
           LineTo(xx+c,yy-Disp[2,c]);
     end;

     if d0=3 then begin
        pen.color:=clpurple;
        sumval := disp[1,1] + disp[2,1];
        if sumval > 255 then sumval := 255;
        moveto(xx,yy-sumval);
        for c:= 1 to 500 do begin
           sumval := disp[1,c]+disp[2,1];
           if sumval > 255 then sumval := 255;
           lineto(xx-1+c,yy-sumval);
        end;
     end;
  end;
  { drawing cursors on the screen }
  if (cursorbuttontag1 = true) or (cursorbuttontag2 = true) then
    with scn.canvas do begin
      ETmin := CalculateTimeValue (-250,MainScreen.TimeBaseSetting.Itemindex,
                                   NumSamplesDiv,MainScreen.xoff);
      ETmax := CalculateTimeValue (250,MainScreen.TimeBaseSetting.Itemindex,
                                   NumSamplesDiv,MainScreen.xoff);
      pen.color := clpurple;
      case mainscreen.cursor.itemindex of
      1: begin
           if (cursorbuttontag1 = true) and
              (et1 >= etmin) and (et1 <= etmax) then begin
             eval1 := round(500*((et1-etmin)/(etmax-etmin)))-250;
             moveto (eVal1+273,23); lineto (eVal1+273,279);
             moveto (eVal1+273-5,23);
             lineto (eVal1+273-5,23-5);
             lineto (eVal1+273,23);
             lineto (eVal1+273+5,23-5);
             lineto (eVal1+273+5,23);
           end;
           if (cursorbuttontag2 = true) and
              (et2 >= etmin) and (et2 <= etmax) then begin
             eval2 := round(500*((et2-etmin)/(etmax-etmin)))-250;
             moveto (eVal2+273,23); lineto (eVal2+273,279);
             moveto (eVal2+273-5,23);
             lineto (eVal2+273-5,23-5);
             lineto (eVal2+273,23);
             lineto (eVal2+273+5,23-5);
             lineto (eVal2+273+5,23);
           end;
         end;
      2: begin
           if cursorbuttontag1 = true then begin
             moveto (23,256-VVal1+23); lineto (523,256-VVal1+23); end;
           if cursorbuttontag2 = true then begin
             moveto (23,256-VVal2+23); lineto (523,256-VVal2+23); end;
         end;
      end;
    end;
end;

{************************************************
  Clears the waveform window and redraws the grid
*************************************************}
procedure DrawScreen;
var x,y,c:word;
begin
  MainScreen.Image1.canvas.draw(0,0,scn);
end;

{***********************************************
  Reads back the captured data from the DSOA.
  The DSOA hardware MUST be in EOS mode before
  this procedure is called.
  Does NOT reset the DSOA hardware
************************************************}
procedure RetrieveData;
var c,x,x1:word;
begin
  x := random(99)+1;
  x1 := 1;{random(3);}
  for c:=1 to RAMsize do begin
     if not DebugMode then begin                    {read real data}
        DSOA_Address(TRUE);        {ouput data}
        Data[1,c]:=DSOA_ReadByteA; {CH1 data}
        Data[2,c]:=DSOA_ReadByteB; {CH2 data}
        DSOA_Address(FALSE);  {TRI-STATE data}
     end
     else begin                       {simulate data}
        Data[1,c]:=Simul_data(1,c,x,x1);
        Data[2,c]:=Simul_data(2,c,x,x1+1);
     end;
  end;
end;

{***********************************************
  Calculates the display information based on
  current display options, and generates data
  points to be displayed in the Disp[] array
************************************************}
procedure CalculateDisplay;      {num = clock rate, NumSamplesDiv=samples/div}
var cnt,c,kc,d,l,l0,x,t,yh1,yh2,yl1,yl2,x0,p0,xinc:word;
    clr : tcolor;
function ncolor (nc : tcolor) : tcolor;
begin
  if nc = clAqua     then ncolor := clYellow  else
  if nc = clBlack    then ncolor := clNavy    else
  if nc = clBlue     then ncolor := clPurple  else
  if nc = clDkGray   then ncolor := clBlack   else
  if nc = clFuchsia  then ncolor := clTeal    else
  if nc = clGray     then ncolor := clDkGray  else
  if nc = clGreen    then ncolor := clLime    else
  if nc = clLime     then ncolor := clAqua    else
  if nc = clLtGray   then ncolor := clGray    else
  if nc = clMaroon   then ncolor := clRed     else
  if nc = clNavy     then ncolor := clBlue    else
  if nc = clOlive    then ncolor := clGreen   else
  if nc = clPurple   then ncolor := clMaroon  else
  if nc = clRed      then ncolor := clFuchsia else
  if nc = clSilver   then ncolor := clLtGray  else
  if nc = clTeal     then ncolor := clOlive   else
  if nc = clWhite    then ncolor := clSilver  else
  if nc = clYellow   then ncolor := clWhite   else ncolor := clsilver;
end;
begin
  c := 1;
  x0 := RAMsize div 2;
  p0 := MainScreen.Xoff.Position;
  Case NumSamplesDiv of
     100: x := x0-500;
     40:  x := x0-200-((5-p0)*40);
     20: x := x0-100-((20-p0)*20);
     10: x := x0-50-((45-p0)*10);
     4: x := x0-20-((120-p0)*4);
     2: x := x0-10-((245-p0)*2);

  end;

  Repeat
     Case NumSamplesDiv of
        {*************************************************}
        {   100 Samples / Div = 2 Samples / Pixel         }
        {*************************************************}
        100: begin
           yh1 := data[1,x]; yl1 := yh1;
           yh2 := data[2,x]; yl2 := yh2;
           if data[1,x+1] > yh1 then yh1 := data[1,x+1];
           if data[1,x+1] < yl1 then yl1 := data[1,x+1];
           if data[2,x+1] > yh2 then yh2 := data[2,x+1];
           if data[2,x+1] < yl2 then yl2 := data[2,x+1];
           disp[1,c] := (yl1 + ((yh1-yl1) div 2));
           disp[2,c] := (yl2 + ((yh2-yl2) div 2));
        end;
        {*************************************************}
        {   40 Samples / Div = 4 Samples to 5 pixels      }
        {*************************************************}
        40: begin
           for l := 0 to 3 do begin
              disp[1,c+l] := data[1,x+l];
              disp[2,c+l] := data[2,x+l];
           end;
           disp[1,c+l+1] := disp[1,c+l];{round(data[1,x+l]+((data[1,x+l+1]-data[1,x+l])/2));}
           disp[2,c+l+1] := disp[2,c+l];{round(data[2,x+l]+((data[2,x+l+1]-data[2,x+l])/2));}
         end;
        {*************************************************}
        {  20 Samples / Div = 2 Samples to 5 Pixels       }
        {  10 Samples / Div = 1 Samples to 5 Pixels       }
        {   4 Samples / Div = 2 Samples to 25 Pixels      }
        {   2 Samples / Div = 1 Samples to 25 Pixels      }
        {*************************************************}
        20, 10, 4,
        2: begin
           Case NumSamplesDiv of
              20: begin l0 := 1; cnt := 5;  end;
              10: begin l0 := 4; cnt := 5;  end;
              4: begin l0 := 11; cnt := 25; end;
              2: begin l0 := 24; cnt := 25; end;
           end;
           for l := 0 to l0 do begin
              disp[1,c+l] := data[1,x]+round(l*((data[1,x+1]-data[1,x])/cnt));
              disp[2,c+l] := data[2,x]+round(l*((data[2,x+1]-data[2,x])/cnt));
           end;
           if (NumSamplesDiv = 20) or (NumSamplesDiv = 4) then begin
              disp[1,c+l+1] := disp[1,c+l]+round((data[1,x+1]-data[1,x])/cnt);
              disp[2,c+l+1] := disp[2,c+l]+round((data[2,x+1]-data[2,x])/cnt);
              for t := l+2 to l+l0+2 do begin
                 disp[1,c+t] := data[1,x+1]+round(l*((data[1,x+1]-data[1,x])/cnt));
                 disp[2,c+t] := data[2,x+1]+round(l*((data[2,x+1]-data[2,x])/cnt));
              end;
           end;
        end;
     end;
     Case NumSamplesDiv of
        100: begin inc(x,2); inc(c,1);end;
        40: begin inc(x,4); inc(c,5); end;
        20: begin inc(x,2); inc(c,5); end;
        10: begin inc(x,1); inc(c,5); end;
        4: begin inc(x,2); inc(c,25); end;
        2: begin inc(x,1); inc(c,25); end;
     end;
  Until (c>500);

  { *********************************************************** }
  { ***    Draws the current waveform onto history bitmaps  *** }
  { *********************************************************** }
  if mainscreen.mode.itemindex = 1 then
    for l := 1 to 3 do begin
      with hist[l].canvas do begin
        pen.color := clsilver;
        case l of
           1: begin
              moveto (1,255-disp[1,1]);
              for kc := 2 to 500 do
                lineto (kc,255-disp[1,kc]);
           end;
           2: begin
              moveto (1,255-disp[2,1]);
              for kc := 2 to 500 do
                lineto (kc,255-disp[2,kc]);
           end;
           3: begin
              moveto (1,255-disp[1,1]);
              for kc := 2 to 500 do
                lineto (kc,255-disp[1,kc]);
              moveto (1,255-disp[2,1]);
              for kc := 2 to 500 do
                lineto (kc,255-disp[2,kc]);
           end;
        end;
     end;
  end;
end;

{***********************************************
  Calculates the average of any previous data plus
  the current data and overwrites the current data
  with the calculated average.
************************************************}
procedure CalculateAverage;      {num = clock rate, NumSamplesDiv=samples/div}
var c,d:word;
begin
  if AverageCount>=NumAverages then AverageCount:=0;
  if AverageCount=0 then     {just started averaging ?}
     for c:=1 to RAMsize do begin
        AVRsum[1,c]:=0;      {clear averages}
        AVRsum[2,c]:=0;
     end;
  inc(AverageCount);          {number of averages+1}
  for c:=1 to RAMsize do begin
     inc(AVRsum[1,c],Data[1,c]);   {sum new data CH1}
     inc(AVRsum[2,c],Data[2,c]);   {sum new data CH2}
     Data[1,c]:=AVRsum[1,c] div AverageCount;  {calc average}
     Data[2,c]:=AVRsum[2,c] div AverageCount;  {calc average}
  end;
end;

{***********************************************}
procedure SetupTimebase;
var num,l,dts:byte;
begin
	case MainScreen.TimebaseSetting.ItemIndex of
		0:begin num:=7; NumSamplesDiv:=100; end;
		1:begin num:=7; NumSamplesDiv:=40; end;
		2:begin num:=7; NumSamplesDiv:=20; end;
		3:begin num:=0; NumSamplesDiv:=100; end;
		4:begin num:=0; NumSamplesDiv:=40; end;
		5:begin num:=3; NumSamplesDiv:=100; end;
		6:begin num:=6; NumSamplesDiv:=100; end;
		7:begin num:=6; NumSamplesDiv:=40; end;
		8:begin num:=2; NumSamplesDiv:=100; end;
		9:begin num:=5; NumSamplesDiv:=100; end;
		10:begin num:=5; NumSamplesDiv:=40; end;
		11:begin num:=1; NumSamplesDiv:=100; end;
		12:begin num:=4; NumSamplesDiv:=100; end;
		13:begin num:=4; NumSamplesDiv:=40; end;
		14:begin num:=4; NumSamplesDiv:=20; end;
		15:begin num:=4; NumSamplesDiv:=10; end;
		16:begin num:=4; NumSamplesDiv:=4; end;
		17:begin num:=4; NumSamplesDiv:=2; end;
		else begin num:=7; NumSamplesDiv:=100; end;
  end;
  DSOA_Clock(num);

  if MainScreen.Delay.checked then
  	begin
     	dts := MainScreen.DelayTimeBase.ItemIndex;
        case MainScreen.TimeBaseSetting.ItemIndex of
           0,1,2 : NumSamplesDiv := tval[dts];
           3,4   : NumSamplesDiv := tval[dts-3];
           5     : NumSamplesDiv := tval[dts-5];
           6,7   : NumSamplesDiv := tval[dts-6];
           8     : NumSamplesDiv := tval[dts-8];
           9,10  : NumSamplesDiv := tval[dts-9];
           11    : NumSamplesDiv := tval[dts-11];
           12,13,14,15,16,17
                 : NumSamplesDiv := tval[dts-12];
           else numsamplesdiv := tval[0];
        end;
     end;

  with MainScreen.Xoff Do begin
     case NumSamplesDiv of
        100: begin min:=1;max:=3; position:=2;   end;
        40: begin min:=0;max:=10; position:=5;   end;
        20: begin min:=0;max:=40; position:=20;  end;
        10: begin min:=0;max:=90; position:=45;  end;
        4: begin min:=0;max:=240; position:=120; end;
        2: begin min:=0;max:=490; position:=245; end;
     end;
  end;
  with Mainscreen do begin
  ETmin := CalculateTimeValue (-250,TimeBaseSetting.Itemindex,NumSamplesDiv,xoff);
  ETmax := CalculateTimeValue (250,TimeBaseSetting.Itemindex,NumSamplesDiv,xoff);
  end;

{  ClearHistoryDisplay;}
end;

{***********************************************
       clear the data arrays
 ***********************************************}
procedure clear_buffer;
var l : word;
begin
  for l := 1 to RAMsize do begin
    data[1,l] := 0;
    data[2,l] := 0;
  end;
end;

{***********************************************
   calculate display cursor information
 ***********************************************}
function CalcTime(tv : integer) : string;
begin
  CalcTime := CalculateTime (Tv,Mainscreen.TimeBaseSetting.Itemindex,
                             NumSamplesDiv,Mainscreen.xoff);
end;

{***********************************************}
function CalcVolt(vval,channel : word) : string;
var cv : double;
    s  : string;
begin
  if channel = 1 then begin
    Case MainScreen.CH1setting.ItemIndex of
    0: cv := (vval/32)*5;
    1: cv := (vval/32)*2;
    2: cv := (vval/32)*1;
    3: cv := (vval/32)*500e-3;
    4: cv := (vval/32)*200e-3;
    5: cv := (vval/32)*100e-3;
    6: cv := (vval/32)*50e-3;
    end;
  end;
  if channel = 2 then begin
    Case MainScreen.CH2setting.ItemIndex of
    0: cv := (vval/32)*5;
    1: cv := (vval/32)*2;
    2: cv := (vval/32)*1;
    3: cv := (vval/32)*500e-3;
    4: cv := (vval/32)*200e-3;
    5: cv := (vval/32)*100e-3;
    6: cv := (vval/32)*50e-3;
    end;
  end;

  if cv = 0 then
    CalcVolt := '0V'
  else if cv < 1 then begin
    str ((cv*1e3):4:2,s);
    CalcVolt := s+'mV';
  end else begin
    str (cv:4:2,s);
    CalcVolt := s+'V';
  end;
end;

{***********************************************}
function CalcTDiff (t1,t2 : integer) : string;
begin
end;

{***********************************************}
function CalcVDiff (v1,v2,ch : integer) : string;
begin
  CalcVDiff := CalcVolt (abs(v1-v2),ch);
end;

{***********************************************}
procedure exit_program;
var f : file of word;
begin
  assignfile (f,cfgfilename);
  rewrite (f);
  write (f,portaddr);
  closefile (f);
  {ShowMessage('Saving Configuration... Click OK when complete.');}
  halt;
end;

{***********************************************}
procedure tickaverage(nav:integer);
begin
  NumAverages := nav;
  with MainScreen do begin
    AVR128.Checked:=FALSE;
    AVR64.Checked:=FALSE;
    AVR32.Checked:=FALSE;
    AVR16.Checked:=FALSE;
    AVR8.Checked:=FALSE;
    AVR4.Checked:=FALSE;
    case nav of
    128 : AVR128.Checked:=TRUE;
     64 : AVR64.Checked:=TRUE;
     32 : AVR32.Checked:=TRUE;
     16 : AVR16.Checked:=TRUE;
      8 : AVR8.Checked:=TRUE;
      4 : AVR4.Checked:=TRUE;
    end;
  end;
end;

{***********************************************
  The main DSOA control and screen update routine
************************************************}
procedure TMainScreen.MainLoop(Sender: TObject);
var l :word; s : string;
begin
  if TrigMode.ItemIndex=1 then  {AUTO trigger mode ?}
     if AutoTimeout then begin
        DSOA_Trigger;   {force trigger}
        AutoTimeout:=FALSE;
     end;
  if stat.run then begin     {only process in RUN mode}
     if DSOA_EOS then begin
        RetrieveData;
        DSOA_Address(FALSE);
        DSOA_Reset;
        if not stat.mode then stat.run := false;
     end;
  end;
  if Mode.ItemIndex = 2 then CalculateAverage
     else AverageCount:=0;
  CalculateDisplay;
  DrawScreen;
  DrawWaveforms;

  Stat.Channel   := MainScreen.Display.ItemIndex; {0=ch1, 1=ch2, 2=both, 3=add, 4=sub}
  Stat.volts1    := MainScreen.CH1setting.ItemIndex; { voltage / div setting (index value)}
  Stat.volts2    := MainScreen.CH2setting.ItemIndex;
  Stat.timebase  := MainScreen.TimeBaseSetting.ItemIndex; { time / div setting (index setting)}
  Stat.Delay     := MainScreen.DelayTimeBase.ItemIndex; { time / div Setting (index Setting)}
  Stat.samples   := NumSamplesDiv; { number of sample per division to be displayed}
  Stat.DelayMode := MainScreen.Delay.Checked; { true = delay time base }
  Stat.DispMode  := MainScreen.Mode.ItemIndex; {0 = RealTime, 1 = History, 2 = Average}

  {**********************************************
     Data Display Window Information update
   **********************************************}
  case cursor.itemindex of
  0 : begin
        { ****************************************************
              Display information when cursor is off mode
          ****************************************************}
          {line1.caption := '';} {'Time = '  +CalcTime(timeval);}
          if (stat.mode = true) and (stat.run = true) then
            line1.caption := 'Sampling Data'
          else
            line1.caption := 'Stopped Sampling';
          line2.caption := ''; {'Volt A = '+CalcVolt(VoltVal,1);}
          line3.caption := ''; {'Volt B = '+CalcVolt(VoltVal,2);}
          str(NumAverages,s);   line4.caption := '#Averages = '+s;
          str(NumSamplesDiv,s); line5.caption := '#Samples/Div = '+s;
      end;
  1 : begin
        { ****************************************************
              Display information when cursor is TIME mode
          ****************************************************}
          line1.caption := 'Time (A) = '+ DisplayEngTime(et1);
          line2.caption := 'Time (B) = '+ DisplayEngTime(et2);
          line3.caption := 'Time (B-A) ='+ DisplayEngTime(abs(et2-et1));
          line4.caption := 'Disp.(MIN) ='+DisplayEngTime(etmin);
          line5.caption := 'Disp.(MAX) ='+DisplayEngTime(etmax);
      end;
  2 : begin
        { ****************************************************
              Display information when cursor is VOLTS mode
          ****************************************************}
          str(vval1,s); line1.caption := 'Volt (A) = '+CalcVolt(VVal1,1);
          str(vval2,s); line2.caption := 'Volt (B) = '+CalcVolt(VVal2,1);
          line3.caption := '';
          line4.caption := '';
          line5.caption := 'Volt Diff = '+CalcVDiff(vval1,vval2,1);
      end;
  end;
end;

{************************************************
  Initialises variables on program start
*************************************************}
procedure TMainScreen.InitialiseData(Sender: TObject);
var xx,yy,l : word;
    f : file of word;
begin
  MainScreen.Height := 480;
  MainScreen.Width := 640;
  xx := 545; yy := 301;
  PortAddr:=$3bc;
  if FileExists(cfgfilename) then
    begin
      assignfile(f,cfgfilename);
      reset(f);
      read(f,PortAddr);
      closefile(f);
    end;
  n378h1.checked := false;
  n278h1.checked := false;
  n3bch1.checked := false;
  case portaddr of
  $378 : n378h1.checked := true;
  $278 : n278h1.checked := true;
  $3bc : n3bch1.checked := true;
  end;
  Display.ItemIndex:=0;         {Select CH1 only}
  Mode.ItemIndex:=0;            {Select Reatime}
  Cursor.ItemIndex:=0;          {Cursors OFF}
  CH1setting.ItemIndex:=1;      {2V/div}
  CH2setting.ItemIndex:=1;      {2V/div}
  TimeBaseSetting.ItemIndex:=0; {100ms/div}
  DelayTimeBase.ItemIndex := TimeBaseSetting.ItemIndex;
  TrigPol.itemindex := 0;       {Positive Trigger}
  stat.mode := true;            {set to continous mode}
  stat.run := true;
  DSOA_Clock(7);
  Grid:=TRUE; Graticule.checked := true; {GRID ON}
  DSOA_Address(FALSE);
  DSOA_Trigger;
  DSOA_Reset;
  NumSamplesDiv:=100;
  cursorbuttontag1 := false;
  cursorbuttontag2 := false;
  tickaverage(128);
  TrigMode.ItemIndex:=1;        {Auto triggering}
  scn := tbitmap.create;
  blankscn := tbitmap.create;
  for l := 1 to 3 do begin
    hist[l] := tbitmap.create;
    hist[l].height := 256;
    hist[l].width := 501;
    with hist[l].canvas do begin
      pen.color := clwhite;
      rectangle (0,0,500,255);
    end;
  end;
  scn.height := yy+1;
  scn.width := xx+1;
  blankscn.height := yy+1;
  blankscn.width := xx+1;
  Draw_border (0,0,xx,yy,scn.canvas); {draw screen onto bitmap}
  blankscn.canvas.draw (0,0,scn);
  SetupTimebase;
  ETmin := CalculateTimeValue (-250,TimeBaseSetting.Itemindex,NumSamplesDiv,xoff);
  ETmax := CalculateTimeValue (250,TimeBaseSetting.Itemindex,NumSamplesDiv,xoff);
end;

{************************************************
  Changes the DSOA timebase based on the current
  timebase setting
*************************************************}
procedure TMainScreen.SetTimebase(Sender: TObject);
begin
  DelayTimebase.ItemIndex := TimebaseSetting.ItemIndex;
  SetupTimebase;
{  if not stat.mode then clear_buffer;}
  clear_buffer;
end;

{************************************************
  Change parallel port address
************************************************}
procedure TMainScreen.N378H1Click(Sender: TObject);
begin
  n378h1.checked := true;
  n278h1.checked := false;
  n3bch1.checked := false;
  PortAddr := $378;
end;

{***********************************************}
procedure TMainScreen.N278H1Click(Sender: TObject);
begin
  n378h1.checked := false;
  n278h1.checked := true;
  n3bch1.checked := false;
  PortAddr := $278;
end;

{***********************************************}
procedure TMainScreen.N3BCH1Click(Sender: TObject);
begin
  n378h1.checked := false;
  n278h1.checked := false;
  n3bch1.checked := true;
  PortAddr := $3bc;
end;

{***********************************************}
procedure TMainScreen.ZoomUpClick(Sender: TObject);
var dts : byte;
begin
  dts := DelayTimeBase.ItemIndex;
  case TimeBaseSetting.ItemIndex of
    0,1,2: if dts< 5 then DelayTimeBase.ItemIndex := dts +1;
    3,4  : if dts< 8 then DelayTimeBase.ItemIndex := dts +1;
    5    : if dts<10 then DelayTimeBase.ItemIndex := dts +1;
    6,7  : if dts<11 then DelayTimeBase.ItemIndex := dts +1;
    8    : if dts<13 then DelayTimeBase.ItemIndex := dts +1;
    9,10 : if dts<14 then DelayTimeBase.ItemIndex := dts +1;
    11   : if dts<16 then DelayTimeBase.ItemIndex := dts +1;
    12,13: if dts<17 then DelayTimeBase.ItemIndex := dts +1;
    14,15,
    16   : if dts<17 then DelayTimeBase.ItemIndex := dts +1;
  end;
  SetupTimebase;
end;

{***********************************************}
procedure TMainScreen.ZoomDownClick(Sender: TObject);
var dts : byte;
begin
  dts := DelayTimeBase.ItemIndex;
  if dts > TimeBaseSetting.ItemIndex then
     DelayTimeBase.ItemIndex := dts -1;
  SetupTimebase;
end;

{***********************************************}
procedure TMainScreen.DelaySetting(Sender: TObject);
begin
  SetupTimebase;
end;

{***********************************************}
procedure TMainScreen.DelayOn(Sender: TObject);
begin
  SetupTimebase;
end;

{***********************************************}
procedure TMainScreen.TimeUpClick(Sender: TObject);
begin
  if TimeBaseSetting.ItemIndex < 18 then
    begin
      TimeBaseSetting.ItemIndex := TimeBaseSetting.ItemIndex + 1;
      DelayTimebase.ItemIndex := TimebaseSetting.ItemIndex;
      SetupTimebase;
    end;
  if stat.mode = false then clear_buffer;
end;

{***********************************************}
procedure TMainScreen.TimeDownClick(Sender: TObject);
begin
  if TimeBaseSetting.ItemIndex > 0 then
    begin
      TimeBaseSetting.ItemIndex := TimeBaseSetting.ItemIndex - 1;
      delaytimebase.itemindex := timebasesetting.itemindex;
      SetupTimebase;
    end;
  if stat.mode = false then clear_buffer;
end;

{***********************************************}
procedure TMainScreen.GraticuleClick(Sender: TObject);
begin
  if Graticule.checked = false then
    Graticule.checked := true else Graticule.checked := false;
    Grid := Graticule.checked;
end;

{***********************************************}
procedure TMainScreen.xoffChange(Sender: TObject);
var l : word;
begin
  ClearHistoryDisplay;
  ETmin := CalculateTimeValue (-250,TimeBaseSetting.Itemindex,NumSamplesDiv,xoff);
  ETmax := CalculateTimeValue (250,TimeBaseSetting.Itemindex,NumSamplesDiv,xoff);
end;

{***********************************************}
procedure TMainScreen.SingleShotClick(Sender: TObject);
begin
  stat.mode := false;
  stat.run := true;
end;

{***********************************************}
procedure TMainScreen.StartSampleClick(Sender: TObject);
begin
  stat.run := true;
  stat.mode := true;
end;

{***********************************************}
procedure TMainScreen.StopSampleClick(Sender: TObject);
begin
  stat.run := false;
  stat.mode := true;
end;

{***********************************************}
procedure TMainScreen.Load1Click(Sender: TObject);
var f : file of file_array;
    DSWFile : file_array;
begin
  Timer1.Enabled:=FALSE;
  if opendialog1.execute then
    begin
      Stat.FileName := opendialog1.filename;
      Stat.run := false;
      Stat.mode := true;
      assignfile (f,opendialog1.filename);
      reset (f);
      read (f,DSWFile);
      closefile (f);
      stat := DSWFile.stat;
      data := DSWFile.data;
    end;
  Timer1.Enabled:=TRUE;
  MainScreen.Display.ItemIndex            := Stat.Channel;
  MainScreen.CH1setting.ItemIndex         := Stat.volts1;
  MainScreen.CH2setting.ItemIndex         := Stat.volts2;
  MainScreen.TimeBaseSetting.ItemIndex    := Stat.timebase;
  MainScreen.DelayTimeBase.ItemIndex      := Stat.Delay;
  NumSamplesDiv                           := Stat.samples;
  MainScreen.Delay.Checked                := Stat.DelayMode;
  MainScreen.Mode.ItemIndex               := Stat.DispMode;

end;

{***********************************************}
procedure TMainScreen.Save1Click(Sender: TObject);
var f : file of File_Array;
    DSWFile : File_Array;
begin
  Timer1.Enabled:=FALSE;
  if savedialog1.execute then
    begin
      Stat.FileName := savedialog1.filename;
      Stat.run := false;
      Stat.mode := true;
      DSWFile.stat := stat;
      DSWFile.Data := Data;
      AssignFile (f,savedialog1.filename);
      rewrite (f);
      write (f,DSWFile);
      CloseFile (f);
    end;
  Timer1.Enabled:=TRUE;
end;

{***********************************************}
procedure TMainScreen.TrigPolClick(Sender: TObject);
begin
  If TrigPol.ItemIndex=1 then DSOA_TriggerPol(TRUE)
     else DSOA_TriggerPol(FALSE);
end;

{***********************************************}
procedure TMainScreen.CH1settingChange(Sender: TObject);
begin
  DSOA_ChangeVoltageA(CH1setting.itemIndex);
end;

{***********************************************}
procedure TMainScreen.CH2settingChange(Sender: TObject);
begin
  DSOA_ChangeVoltageB(CH2setting.itemIndex);
end;

{************************************************
  Sets the AutoTimeout variable TRUE when called
  Used for automatically enabling the trigger
*************************************************}
procedure TMainScreen.Timer2Timer(Sender: TObject);
begin
  AutoTimeout:=TRUE;
end;

{*************************************************
  Dumps the main screen to the printer
*************************************************}
procedure TMainScreen.Print1Click(Sender: TObject);
begin
  MainScreen.Timer1.Enabled:=FALSE;
  printdialog1.execute;
  line1.caption := 'Printing...';
  Print;
  {ShowMessage('Printing... Click OK when complete.');}
  MainScreen.Timer1.Enabled:=TRUE;
end;

{*************************************************
  Calls the printer setup dialog box
*************************************************}
procedure TMainScreen.PrintSetup1Click(Sender: TObject);
begin
  MainScreen.Timer1.Enabled:=FALSE;
  PrinterSetupDialog1.Execute;
  MainScreen.Timer1.Enabled:=TRUE;
end;

{*************************************************}
procedure TMainScreen.About1Click(Sender: TObject);
begin
  MainScreen.Timer1.Enabled:=FALSE;
  AboutBox.Enabled:=TRUE;
  AboutBox.Visible:=TRUE;
  MainScreen.Timer1.Enabled:=TRUE;
end;

{**********************************************
  If MODE box is clicked
***********************************************}
procedure TMainScreen.MODEClick(Sender: TObject);
begin
  if Mode.ItemIndex=1 then ClearHistoryDisplay;
end;

{***********************************************}
procedure TMainScreen.ExitClick(Sender: TObject);
begin
  exit_program;
end;

{***********************************************}
procedure TMainScreen.CursorMark(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if mainscreen.cursor.itemindex = 0 then begin
    cursorbuttontag1 := false; cursorbuttontag2 := false; end;
  if mainscreen.cursor.itemindex > 0 then begin
    if button = mbleft then begin
        cursorbuttontag1 := true;
        if (x >= 23) and (x <= 523) then begin
          TVal1 := (x-23)-250;
          ET1 := CalculateTimeValue (TVal1,TimeBaseSetting.Itemindex,NumSamplesDiv,xoff);
        end;
        if (y >= 23) and (y <= 279) then VVal1 := 256-(y-23);
    end;
    if button = mbright then begin
        cursorbuttontag2 := true;
        if (x >= 23) and (x <= 523) then begin
          TVal2 := (x-23)-250;
          ET2 := CalculateTimeValue (TVal2,TimeBaseSetting.Itemindex,NumSamplesDiv,xoff);
        end;
        if (y >= 23) and (y <= 279) then VVal2 := 256-(y-23);
    end;
  end;
end;

{***********************************************}
procedure TMainScreen.CursorTrace(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  {cursorson := false;
  if (x >= 23) and (x <= 523) then begin TimeVal := (x-23)-250; cursorson := true; end;
  if (y >= 23) and (y <= 279) then begin VoltVal := 256-(y-23); cursorson := true; end;}
end;

{***********************************************}
procedure TMainScreen.AVR128Click(Sender: TObject);
begin
  tickaverage (128);
end;

{***********************************************}
procedure TMainScreen.AVR64Click(Sender: TObject);
begin
  tickaverage (64);
end;

{***********************************************}
procedure TMainScreen.AVR32Click(Sender: TObject);
begin
  tickaverage (32);
end;

{***********************************************}
procedure TMainScreen.AVR16Click(Sender: TObject);
begin
  tickaverage (16);
end;

{**********************************************}
procedure TMainScreen.AVR8Click(Sender: TObject);
begin
  tickaverage (8);
end;

{***********************************************}
procedure TMainScreen.AVR4Click(Sender: TObject);
begin
  tickaverage (4);
end;


procedure TMainScreen.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  exit_program;
end;

end.
